library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use work.GEN_CONST.all;

entity HW1_TEST is
end HW1_TEST;

architecture TESTBENCH of HW1_TEST is

component NEGATOR
  port (
    A : in std_logic_vector(w-1 downto 0);
    Y : out std_logic_vector(w-1 downto 0)
  );
end component;
component MULTIPLEXER
  port (
    SEL : in std_logic;
    A,B : in std_logic_vector(w-1 downto 0);
    Y   : out std_logic_vector(w-1 downto 0)
  );
end component;

signal T_A: std_logic_vector(w-1 downto 0);
signal T_X: std_logic_vector(w-1 downto 0);
signal T_Y: std_logic_vector(w-1 downto 0);
signal T_SEL: std_logic;

begin
  neg: NEGATOR port map (T_A, T_X);
  mx: MULTIPLEXER port map (T_SEL, T_X, T_A, T_Y);

tst: process
begin
-- run 3600
  for i in -128 to 127 loop
    T_A <= conv_std_logic_vector(i, w);
    T_SEL <= '0';
    wait for 6 ns;
    assert conv_std_logic_vector(i, w) = T_Y
		    report "malfunction..."
			severity failure;
	 wait for 1 ns;
  end loop;

  for i in -128 to 127 loop
    T_A <= conv_std_logic_vector(i, w);
    T_SEL <= '1';
    wait for 6 ns;
    assert conv_std_logic_vector(-i, w) = T_Y
		    report "malfunction..."
			severity failure;
	 wait for 1 ns;
  end loop;
  wait for 4192 ns;
end process;
end TESTBENCH;